// === Variablen deklarieren und ggf. initialisieren ===

Private [
	"_introKamera", "_camStartPos", "_camEndPos",
	"_timer", "_gesamtDauer", "_camDir", "_camPos",
	"_camMarkerStartEndePaareMitDauerInSek"
];

cutText ["Lade Mission ...", "BLACK FADED"];

SPALTE_INTROCAMSTARTENDE_STARTMARKER = 0;
SPALTE_INTROCAMSTARTENDE_ENDEMARKER  = 1;
SPALTE_INTROCAMSTARTENDE_DAUERINSEK  = 2;

_camMarkerStartEndePaareMitDauerInSek = [
	["introCam1a", "introCam1b", 6]
	,["introCam2a", "introCam2b", 6]
	,["introCam3a", "introCam3b", 6]
	,["introCam4a", "introCam4b", 6]
	,["introCam5a", "introCam5b", 6]
];

// === Kamera einrichten und auf den ersten Wegpunkt setzen ===

showCinemaBorder true;
_ersterCamMarker = (_camMarkerStartEndePaareMitDauerInSek select 0) select SPALTE_INTROCAMSTARTENDE_STARTMARKER;
_introKamera  = "CAMERA" camCreate (markerPos _ersterCamMarker); // Kamera erstellen
_introKamera cameraEffect ["Internal", "Back"]; // Kameratyp
_introKamera camSetFOV 1.5; // Kamera Sichtfeld
_introKamera setDir (markerDir _ersterCamMarker); // Kameraausrichtung
_introKamera camPrepareFocus [-1, -1]; // Absolut scharfes Bild ohne Unschärfe am Rand
_introKamera camSetFocus [-1, -1]; // Absolut scharfes Bild ohne Unschärfe am Rand
_introKamera camCommit 0; // Kameraeinstellungen anwenden

{
	Private ["_startMarker", "_endeMarker", "_dauerInSek", "_camStartPos", "_camEndPos", "_timer", "_dirVector"];
	
	_startMarker = _x select SPALTE_INTROCAMSTARTENDE_STARTMARKER;
	_endeMarker  = _x select SPALTE_INTROCAMSTARTENDE_ENDEMARKER;
	_dauerInSek  = _x select SPALTE_INTROCAMSTARTENDE_DAUERINSEK;
	
	_camStartPos = markerPos _startMarker;
	_camEndPos   = markerPos _endeMarker;
	
	_timer = 0.0;
	_ausblendenGestartet = false;

	titleText ["", "BLACK IN", 2.5];
	
	while {_timer < _dauerInSek} do
	{
		// === Interpolation von Kameraposition und -winkel zwischen Start- und Endemarker ===
		
		_camPos = [
			(_camStartPos select 0) + (_timer / _dauerInSek) * ((_camEndPos select 0) - (_camStartPos select 0)),
			(_camStartPos select 1) + (_timer / _dauerInSek) * ((_camEndPos select 1) - (_camStartPos select 1)),
			(3.0 + (_camStartPos select 2)) + (_timer / _dauerInSek) * ((_camEndPos select 2) - (_camStartPos select 2))
		];
		
		_camDir = (markerDir _startMarker) + (_timer / _dauerInSek) * ((markerDir _endeMarker) - (markerDir _startMarker));

		_introKamera camSetPos _camPos; // Kameraposition setzen
		//_introKamera setDir _camDir; // Kamerablickwinkel setzen
		
		_dirVector = [
			(_camEndPos select 0) - (_camStartPos select 0),
			(_camEndPos select 1) - (_camStartPos select 1),
			(_camEndPos select 2) - (_camStartPos select 2)
		];
		_introKamera setVectorDirAndUp [_dirVector, [0, 0, 1]];
		_introKamera camCommit 0; // Geänderte Kameraeinstellungen anwenden

		if (!_ausblendenGestartet && _timer > ((2.0/3.0) * _dauerInSek)) then {
			titleText ["", "BLACK OUT", ((1.0/3.0) * _dauerInSek)];
			_ausblendenGestartet = true;
		};
		
		sleep 0.05; // Hundertstel Sekunde warten
		_timer = _timer + 0.05; // Speichern, dass eine Hundertstel Sekunde vergangen ist
	};
}
forEach _camMarkerStartEndePaareMitDauerInSek;

// === Kamera zerstören und somit zur Egoperspektive der Spielers zurückkehren ===

_introKamera cameraEffect ["TERMINATE","BACK"];
camDestroy _introKamera;

titleText ["", "BLACK IN", 1.0];